/*

Copyright 1992 by the University of Edinburgh, Department of Computer Science

Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation, and that the name of the University of Edinburgh not be used
in advertising or publicity pertaining to distribution of the software
without specific, written prior permission.  The University of Edinburgh
makes no representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

*/
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <string.h>
#include <stdio.h>

main(argc, argv)
int argc;
char **argv;
{	struct hostent *h;
	char *host, *fullhost, *domain;
	int lh, lfh, ld;
	char *chop;

	if (argc != 3) {
		(void) printf("%s: wrong number of parameters\n", *argv);
		exit(1);
	}

	host = *++argv;
	domain = *++argv;

	h = gethostbyname(host);
#ifdef DEBUG
	(void) printf("%s %s %s\n",
		host, h ? h->h_name : "(non-existent)", domain);
#endif

	if (!h) exit(1);  /* non-existent */

	fullhost = h->h_name;
	lh = strlen(host);
	lfh = strlen(fullhost);
	ld = strlen(domain);
#ifdef DEBUG
	(void) printf("Host %d, fullhost %d, domain %d\n", lh, lfh, ld);
#endif

	if (ld >= lfh) exit(1);  /* can't be ours: name shorter than domain */

	chop = fullhost + lfh - ld;
#ifdef DEBUG
	(void) printf("Chop -> %s\n", chop);
#endif
	if (strcmp(chop, domain)) exit(1);  /* not ours, wrong domain */
	exit(0);
}
